## ros-indigo-cv-backports 0.1.4

=== CMakeLists.txt ===
##############################################################################
# Cmake
##############################################################################

cmake_minimum_required(VERSION 2.8.3)
project(cv_backports)

##############################################################################
# Find Packages
##############################################################################

find_package(catkin REQUIRED COMPONENTS
    roslib
)
find_package(Qt4 REQUIRED)
include(${QT_USE_FILE})
find_package(OpenCV REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

add_definitions(${Qt4_DEFINITIONS})
add_definitions(${OpenCV_DEFINITIONS})
include_directories(include ${catkin_INCLUDE_DIRS})
include_directories(${QT_INCLUDE_DIR} ${QT_INCLUDE_DIR}/QtCore ${QT_INCLUDE_DIR}/QtGui)
include_directories(${OpenCV_INCLUDE_DIRS})

##############################################################################
# Catkin
##############################################################################

catkin_package(
    INCLUDE_DIRS include 
    LIBRARIES ${PROJECT_NAME}
    DEPENDS OpenCV
)

##############################################################################
# Sources
##############################################################################

add_subdirectory(include)
add_subdirectory(src)

##############################################################################
# Installs
##############################################################################

install(DIRECTORY resources DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

=== include/CMakeLists.txt ===
##############################################################################
# Subdirectories
##############################################################################

add_subdirectory(${PROJECT_NAME})

=== src/CMakeLists.txt ===
###############################################################################
# Subdirectories
###############################################################################

add_subdirectory(lib)

###############################################################################
# Binaries
###############################################################################

add_executable(imshow imshow.cpp)
target_link_libraries(imshow ${OpenCV_LIBRARIES} ${catkin_LIBRARIES})
install(TARGETS imshow RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

add_executable(imshow_backports imshow_backports.cpp)
target_link_libraries(imshow_backports ${PROJECT_NAME} ${OpenCV_LIBRARIES} ${catkin_LIBRARIES})
install(TARGETS imshow_backports RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

=== include/cv_backports/CMakeLists.txt ===
##############################################################################
# Subdirectories
##############################################################################

add_subdirectory(impl)
                                                                 
###############################################################################
# Files
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.hpp)

install(FILES ${HEADERS} DESTINATION include/${PROJECT_NAME})

=== src/lib/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

file(GLOB SOURCES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.cpp) 

##############################################################################
# QT
##############################################################################

if(HAVE_QT_OPENGL)
  set(QT_USE_QTOPENGL TRUE)
endif()
#include(${QT_USE_FILE})

QT4_ADD_RESOURCES(_RCC_OUTFILES window_QT.qrc)
QT4_WRAP_CPP(_MOC_OUTFILES window_QT.h)

list(APPEND SOURCES ${_MOC_OUTFILES} ${_RCC_OUTFILES})
#ocv_check_flag_support(CXX -Wno-missing-declarations _have_flag)
#if(${_have_flag})
#  set_source_files_properties(${_RCC_OUTFILES} PROPERTIES COMPILE_FLAGS -Wno-missing-declarations)
#endif()

##############################################################################
# Library
##############################################################################

add_library(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME}
                          ${catkin_LIBRARIES}
                          ${OpenCV_LIBRARIES}
                          ${QT_QTCORE_LIBRARY}
                          ${QT_QTGUI_LIBRARY}
                          ${QT_QTTEST_LIBRARY}
)

##############################################################################
# Installs
##############################################################################

install(TARGETS ${PROJECT_NAME}
   RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== include/cv_backports/impl/CMakeLists.txt ===
###############################################################################
# Files
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.hpp)

install(FILES ${HEADERS} DESTINATION include/${PROJECT_NAME}/impl)

=== debian/changelog ===
ros-indigo-cv-backports (0.1.4-0trusty) trusty; urgency=high

  * fix qt dependency lookup in cmake

 -- Daniel Stonier <d.stonier@gmail.com>  Wed, 16 Mar 2016 15:00:00 -0000

ros-indigo-cv-backports (0.1.3-0trusty) trusty; urgency=high

  * Install rules for headers.

 -- Daniel Stonier <d.stonier@gmail.com>  Mon, 22 Sep 2014 15:00:00 -0000

ros-indigo-cv-backports (0.1.2-0trusty) trusty; urgency=high

  * Bugfix hanging problems due to global variable name conflicts with opencv.

 -- Daniel Stonier <d.stonier@gmail.com>  Tue, 16 Sep 2014 15:00:00 -0000

ros-indigo-cv-backports (0.1.1-0trusty) trusty; urgency=high

  * bugfix parallel thread support

 -- Daniel Stonier <d.stonier@gmail.com>  Sun, 14 Sep 2014 15:00:00 -0000

ros-indigo-cv-backports (0.1.0-0trusty) trusty; urgency=high

  * pull in 2.4.9.2 parallel qt threading support for imshows
  * pull in 2.4.9.1 zoomable imshows

 -- Daniel Stonier <d.stonier@gmail.com>  Sun, 14 Sep 2014 15:00:00 -0000

=== debian/control ===
Source: ros-indigo-cv-backports
Section: misc
Priority: extra
Maintainer: Daniel Stonier <d.stonier@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libopencv-dev, libqt4-dev, libqtgui4, ros-indigo-catkin, ros-indigo-roslib
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-cv-backports
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopencv-dev, libqtgui4, ros-indigo-roslib
Description: Backporting features from the 2.4.x.y series of opencv releases to indigo.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-cv-backports//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
